package seniorproj;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

/**
 * Creates a GUI for a user to customize the aggregate expression to
 * tailor his/her needs. 
 * 
 * @author Steven Weigand
 *
 */
public class CustomDependent {
	
	/**
	 * The frame containing the GUI components.
	 */
	static JFrame frame = null;
	
	/**
	 * The text area containing the name.
	 */
	static JTextArea name = null;
	
	/**
	 * The text area containing the variable.
	 */
	static JTextArea var = null;

	/**
	 * Creates the GUI layout for a user to customize a dependent variable
	 * for the warehouse.
	 */
	public static void createCustomDVar() {
		
        frame = new JFrame("CSC 467: Custom Dependent");

        Container content = frame.getContentPane();
        content.setLayout(new BoxLayout(content, BoxLayout.Y_AXIS));
        content.setBackground(Color.GRAY);
        
        //Enter alias for variable here
        JPanel all = new JPanel();
        JLabel alias = new JLabel("Enter Alias:");
        all.add(alias);
        
        name = new JTextArea(1, 20);
        all.add(name);
        
        //Enter expression for variable here
        JLabel expr = new JLabel("Enter Expression:");
        all.add(expr);
        
        var = new JTextArea(SelectDependents.pnode.toString()+"."+(String)SelectDependents.selectedValue, 1, 20);
        all.add(var);
        
        //Create add button to put in list
        JButton add = new JButton("Add");
        add.addActionListener(new ButtonListener());
        all.add(add);
        
        content.add(all);
        
        //Display the window.
        frame.setLocationRelativeTo(SelectDependents.frame);
        frame.setPreferredSize(new Dimension(300, 200));
        frame.pack();
        frame.setVisible(true);        
	}
	
	/**
	 * Listener for the "add" button that will add the dependent variable to the table.
	 */
    static class ButtonListener implements ActionListener {
    	
    	/**
    	 * Used to catch when the add button is pressed.
    	 * 
    	 * @param e		Mouse pressed action event
    	 */
    	public void actionPerformed(ActionEvent e) {
    		
    		String element = SelectDependents.pnode.toString()+"."+SelectDependents.selectedValue;
    		Column col = null;
    		String temp = null;
    		String expr = null;
    		
    		//If a name and expression is given
			if(!name.getText().equals("") && !var.getText().equals("")) {
				for(int i = 0; i < SelectAttr.colindex; i++) {
					temp = SelectAttr.allColumns[i].getTname()+"."+SelectAttr.allColumns[i].getName();
					if(element.equals(temp)) {
						col = SelectAttr.allColumns[i];
					}
				}
			
				//Create new dependent var and add to array
				DependentVar variable = new DependentVar(name.getText(), var.getText(), col, 1);
				SelectDependents.vars[SelectDependents.vindex++] = variable;
				
				expr = var.getText();
				expr += " as "+name.getText();
				SelectDependents.listModel.addElement(expr);
	    		
	        	frame.setVisible(false);
			}
			else {
    			JOptionPane.showMessageDialog(frame, "Make sure you enter an expression and an alias");
			}
    	}
    }
}
