package seniorproj;

/**
 * Creates a dataset object containing a name, tables, and the number of tables.
 * 
 * @author Steven Weigand
 *
 */
public class DataSet {
	
	String id;
	Object tablenames[];
	int index;
	
	/**
	 * Default constructor for initialization.
	 */
	public DataSet() {}
	
	/**
	 * Initializes and creates a DataSet object.
	 * 
	 * @param name		name of the dataset
	 * @param tnames	array of table names in dataset
	 * @param index		the number of table names in dataset
	 */
	public DataSet(String name, Object[] tnames, int index) {
		this.id = name;
		this.tablenames = new String[tnames.length];
		this.tablenames = tnames;
		this.index = index;
	}
	
	/**
	 * Retrieves the table names for the user.
	 * 
	 * @return		returns the array of table names
	 */
	public Object[] getNames() {
		return tablenames;
	}
	
	/**
	 * Retrieves the dataset name for the user.
	 * 
	 * @return		the id of the dataset
	 */
	public String getName() {
		return id;
	}
}
