package seniorproj;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import javax.swing.*;

/**
 * Creates a GUI for a user to specify a filename in which
 * to export his/her SQL code to. 
 * 
 * @author Stevo
 */
public class ExportSQLGUI {
	
    /**
     * The frame containing the GUI components.
     */
	static JFrame frame = null;
	
    /**
     * Textfield containing name of file to store code in.
     */
	static JTextField name = null;
	
    /**
     * Button used by user to export code.
     */
	static JButton export = null;
	
	/**
	 * Creates GUI layout for user to specify a filename to export the warehouse
	 * sql to.
	 */
	public static void chooseNameGUI() {
		
        frame = new JFrame("CSC 467: Export SQL");

        Container content = frame.getContentPane();
        content.setLayout(new BoxLayout(content, BoxLayout.Y_AXIS));
        
        //Enter name 
        JPanel enterName = new JPanel();
        JLabel choose = new JLabel("File Name:");
        enterName.add(choose); 
        name = new JTextField(15);
        enterName.add(name);
        
        export = new JButton("Export");
        export.addActionListener(new ButtonListener());
        enterName.add(export);
        
        content.add(enterName);
        
        //Display the window.
        frame.setLocationRelativeTo(TableAnalysis.frame);
        frame.setPreferredSize(new Dimension(400, 100));
        frame.pack();
        frame.setVisible(true); 
	}
	
	/**
	 * Creates a button listener for the "Export" button.
	 */
    static class ButtonListener implements ActionListener {
       	/**
    	 * Used to catch when the export button is selected.
    	 * 
    	 * @param e		Mouse pressed action event
    	 */
    	public void actionPerformed(ActionEvent e) {
	  		PrintWriter out = null;
	    		
	  		if(!name.getText().equals("")) {
		       	try {
		       		out = new PrintWriter(new BufferedWriter(new FileWriter(name.getText())));			
		    			
		    	} catch (IOException e1) {
		    		e1.printStackTrace();
		   		}		
		    		
		    	out.println(TableAnalysis.code);
		    	out.close();
		    	
		    	frame.setVisible(false);
	  		}
	  		else {
    			JOptionPane.showMessageDialog(frame, "You must provide a filename");
	  		}
	    }
    }
}
